from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, String

Anvi_Matrix_To_Newick_V0_1_0 = CommandToolBuilder(tool="anvi_matrix_to_newick", base_command=["anvi-matrix-to-newick"], inputs=[ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--output-file", doc=InputDocumentation(doc="File path to store results.")), ToolInput(tag="in_items_order_file", input_type=File(optional=True), prefix="--items-order-file", doc=InputDocumentation(doc="PATH\nIn addition to a newick formatted output file, you can\nask anvi'o to report the order of items in the\nresulting tree in a separate file. The content of this\nfile will be a single-column item names the way they\nare ordered in the output newick dendrogram.")), ToolInput(tag="in_transpose", input_type=Boolean(optional=True), prefix="--transpose", doc=InputDocumentation(doc="Transpose the input matrix file before clustering.")), ToolInput(tag="in_distance", input_type=String(optional=True), prefix="--distance", doc=InputDocumentation(doc="The distance metric for the hierarchical clustering.\nThe default distance metric is 'euclidean'. You can\nfind the full list of distance metrics either by\nmaking a mistake (such as entering a non-existent\ndistance metric and making anvi'o upset), or by taking\na look at the help menu of the\nhierarchy.distance.pdist function in the scipy.cluster\nmodule.")), ToolInput(tag="in_linkage", input_type=String(optional=True), prefix="--linkage", doc=InputDocumentation(doc="The linkage method for the hierarchical clustering.\nThe default linkage method is 'ward', because that is\nthe best one. It really is. We talked to a lot of\npeople and they were all like 'this is the best one\navailable' and it is just all out there. Honestly it\nis so good that we will build a wall around it and\nmake other linkage methods pay for it. But if you want\nto see a full list of available ones you can check the\nhierarcy.linkage function in the scipy.cluster module.\nUp to you really. But then you can't use ward anymore,\nand you would have to leave anvi'o right now.\n"))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="File path to store results.")), ToolOutput(tag="out_items_order_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_items_order_file", type_hint=File()), doc=OutputDocumentation(doc="PATH\nIn addition to a newick formatted output file, you can\nask anvi'o to report the order of items in the\nresulting tree in a separate file. The content of this\nfile will be a single-column item names the way they\nare ordered in the output newick dendrogram."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Matrix_To_Newick_V0_1_0().translate("wdl", allow_empty_container=True)

